Subject: Re: Arm64 crash while reading memory sysfs

From: Catalin Marinas <[email-masked]>
Date: Thu, 27 May 2021 18:50:48 +0100

On Thu, May 27, 2021 at 07:22:00PM +0300, Mike Rapoport wrote:
> On Thu, May 27, 2021 at 10:33:13AM -0400, Qian Cai wrote:
> > On 5/27/2021 4:56 AM, Mike Rapoport wrote:
> > > Let's drop memblock=debug for now and add this instead:
> > 
> > [    0.000000][    T0] Booting Linux on physical CPU 0x0000000000 [0x503f0002]
> > [    0.000000][    T0] Linux version 5.13.0-rc3-next-20210526+ (root@admin5) (gcc (Ubuntu 9.3.0-17ubuntu1~20.04) 9.3.0, GNU ld (GNU Binutils for Ubuntu) 2.34) #31 SMP Thu May 27 12:32:40 UTC 2021
> > [    0.000000][    T0] Inode-cache hash table entries: 4194304 (order: 9, 33554432 bytes, linear)
> > [    0.000000][    T0] mem auto-init: stack:off, heap alloc:on, heap free:off
> > [    0.000000][    T0] MEMBLOCK configuration:
> > [    0.000000][    T0]  memory size = 0x0000001ff0000000 reserved size = 0x0000000421e33ae8
> > [    0.000000][    T0]  memory.cnt  = 0xc
> > [    0.000000][    T0] Memory: 777216K/133955584K available (17984K kernel code, 118722K rwdata, 4416K rodata, 6080K init, 67276K bss, 17379072K reserved, 0K cma-reserved)
> 
> I still cannot understand where most of the memory disappeared, but it
> seems entirely different issue.
>  
> > > Sorry, I've missed that the BUG is apparently triggered for pfn + i. Can
> > > you please try this instead:
> > 
> > [  259.216661][ T1417] test_pages_in_a_zone: pfn 8000 is not valid
> > [  259.226547][ T1417] page:00000000f4aa8c5c is uninitialized and poisoned
> > [  259.226560][ T1417] page dumped because: VM_BUG_ON_PAGE(PagePoisoned(p))
> 
> Can you please try Anshuman's patch "arm64/mm: Drop HAVE_ARCH_PFN_VALID":
> 
> https://lore.kernel.org/lkml/[email-masked]
> 
> It seems to me that the check for memblock_is_memory() in
> arm64::pfn_valid() is what makes init_unavailable_range() to bail out for
> section parts that are not actually populated and then we have
> VM_BUG_ON_PAGE(PagePoisoned(p)) for these pages.

I acked Anshuman's patch, I think they all need to go in together.

-- 
Catalin

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel